## qevercloud 3.0.3+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/QEverCloud/cmake/modules")
include(QEverCloudCMakePolicies)
SET_POLICIES()

if("${CMAKE_MAJOR_VERSION}" GREATER "2")
  project(QEverCloud
          VERSION 3.0.3)
else()
  project(QEverCloud)
  set(PROJECT_VERSION_MAJOR "3")
  set(PROJECT_VERSION_MINOR "0")
  set(PROJECT_VERSION_PATCH "3")
  set(PROJECT_VERSION_COUNT 3)
  set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
endif()

set(PROJECT_VENDOR "Dmitry Ivanov")
set(PROJECT_COPYRIGHT_YEAR "2015-2016")
set(PROJECT_DOMAIN_FIRST "qevercloud")
set(PROJECT_DOMAIN_SECOND "com")
set(PROJECT_DOMAIN "${PROJECT_DOMAIN_FIRST}.${PROJECT_DOMAIN_SECOND}")

include(QEverCloudDoxygen)

set(BUILD_DOCUMENTATION ON CACHE BOOL "Build documentation for QEverCloud")
set(BUILD_QCH_DOCUMENTATION OFF CACHE BOOL "Build documentation for QEverCloud in qch format")

if(BUILD_DOCUMENTATION)
  # set Doxygen documentation properties
  set(DOXY_INPUT "${PROJECT_SOURCE_DIR}/QEverCloud/headers ${PROJECT_SOURCE_DIR}/README.md")
  set(DOXY_USE_MDFILE_AS_MAINPAGE "${PROJECT_SOURCE_DIR}/README.md")
  set(DOXY_RECURSIVE "YES")
  set(DOXY_PROJECT_NAME ${PROJECT_NAME})
  set(DOXY_PROJECT_NUMBER "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
  set(DOXY_PROJECT_BRIEF "\"Unofficial Evernote Cloud API for Qt\"")
  set(DOXY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/doc")
  set(DOXY_WARN_IF_UNDOCUMENTED "NO")
  set(DOXY_EXTRACT_ALL "YES")
  if(BUILD_QCH_DOCUMENTATION)
    set(DOXY_GENERATE_QHP "YES")
  else()
    set(DOXY_GENERATE_QHP "NO")
  endif()
  ADD_DOCUMENTATION(doc Doxyfile)
endif()

include(QEverCloudCompilerSettings)
include(QEverCloudSetupQt)

if(USE_QT5)
  set(QEVERCLOUD_QT_VERSION "qt5")
else()
  set(QEVERCLOUD_QT_VERSION "qt4")
endif()

if(NOT CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()

if(NOT CMAKE_INSTALL_BINDIR)
  set(CMAKE_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
endif()

if(NOT CMAKE_INSTALL_INCLUDEDIR)
  set(CMAKE_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif()

if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_PREFIX}/CMake")
else()
  set(DEF_INSTALL_CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/QEverCloud-${QEVERCLOUD_QT_VERSION}")
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")

if(MSVC)
  set(QEVERCLOUD_LIBNAME_PREFIX "lib")
else()
  set(QEVERCLOUD_LIBNAME_PREFIX "")
endif()

configure_file(QEverCloud/cmake/modules/QEverCloudBuildTreeSettings.cmake.in
  ${PROJECT_BINARY_DIR}/QEverCloud-${QEVERCLOUD_QT_VERSION}BuildTreeSettings.cmake @ONLY)
configure_file(QEverCloud/cmake/modules/QEverCloudConfig.cmake.in
  ${PROJECT_BINARY_DIR}/QEverCloud-${QEVERCLOUD_QT_VERSION}Config.cmake @ONLY)
configure_file(QEverCloud/cmake/modules/QEverCloudConfigVersion.cmake.in
  ${PROJECT_BINARY_DIR}/QEverCloud-${QEVERCLOUD_QT_VERSION}ConfigVersion.cmake @ONLY)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
enable_testing()

add_subdirectory(QEverCloud)

add_custom_target(check COMMAND "${CMAKE_CTEST_COMMAND}" "--verbose")

=== QEverCloud/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

include(QEverCloudCMakePolicies)
SET_POLICIES()

set(QEVERCLOUD_BINARY_DIR ${PROJECT_BINARY_DIR})

set(PUBLIC_HEADERS
    headers/QEverCloud.h
    headers/QEverCloudOAuth.h)

set(NON_GENERATED_HEADERS
    headers/export.h
    headers/oauth.h
    headers/exceptions.h
    headers/globals.h
    headers/thumbnail.h
    headers/AsyncResult.h
    headers/Optional.h
    headers/EverCloudException.h
    headers/qt4helpers.h
    headers/EventLoopFinisher.h)

set(GENERATED_HEADERS
    headers/generated/constants.h
    headers/generated/services.h
    headers/generated/types.h
    headers/generated/EDAMErrorCode.h)

set(PRIVATE_HEADERS
    src/thrift.h
    src/http.h
    src/impl.h
    src/generated/types_impl.h)

set(SOURCES
    src/globals.cpp
    src/exceptions.cpp
    src/oauth.cpp
    src/http.cpp
    src/services_nongenerated.cpp
    src/AsyncResult.cpp
    src/EverCloudException.cpp
    src/EventLoopFinisher.cpp
    src/thumbnail.cpp
    src/generated/constants.cpp
    src/generated/services.cpp
    src/generated/types.cpp)

set(BUILD_SHARED ON CACHE BOOL "Build shared library, otherwise static library")

set(ALL_HEADERS_AND_SOURCES ${PUBLIC_HEADERS})
list(APPEND ALL_HEADERS_AND_SOURCES ${NON_GENERATED_HEADERS})
list(APPEND ALL_HEADERS_AND_SOURCES ${GENERATED_HEADERS})
list(APPEND ALL_HEADERS_AND_SOURCES ${PRIVATE_HEADERS})
list(APPEND ALL_HEADERS_AND_SOURCES ${SOURCES})

set(LIBNAME "${QEVERCLOUD_LIBNAME_PREFIX}${QEVERCLOUD_QT_VERSION}qevercloud")

if(APPLE)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_LIBDIR})

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if it's not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES ${CMAKE_INSTALL_LIBDIR} isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_LIBDIR})
  endif("${isSystemDir}" STREQUAL "-1")

  # set(CMAKE_SKIP_RPATH TRUE)
endif()

if(BUILD_SHARED)
  add_definitions("-DQEVERCLOUD_SHARED_LIBRARY")
  add_library(${LIBNAME} SHARED ${ALL_HEADERS_AND_SOURCES})
else()
  add_definitions("-DQEVERCLOUD_STATIC_LIBRARY")
  add_library(${LIBNAME} STATIC ${ALL_HEADERS_AND_SOURCES})
endif()

set_target_properties(${LIBNAME} PROPERTIES
  VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
  SOVERSION "${PROJECT_VERSION_MAJOR}")

target_link_libraries(${LIBNAME} ${QT_LIBRARIES})

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/headers)

# Tests
if(USE_QT5)
  find_package(Qt5Test QUIET)
else()
  find_package(QT4 COMPONENTS QTCORE QTTEST QUIET)
endif()

if((USE_QT5 AND Qt5Test_FOUND) OR (NOT USE_QT5 AND Qt4_FOUND))
  set(TEST_SOURCES
      src/tests/TestQEverCloud.cpp)
  add_executable(test_${PROJECT_NAME} ${TEST_SOURCES})
  add_test(test_${PROJECT_NAME} test_${PROJECT_NAME})
  if(USE_QT5)
    target_link_libraries(test_${PROJECT_NAME} ${LIBNAME})
    qt5_use_modules(test_${PROJECT_NAME} Core Test)
  else()
    target_link_libraries(test_${PROJECT_NAME} ${LIBNAME} Qt4::QtCore Qt4::QtTest)
  endif()
else()
  message(STATUS "Haven't found Qt components required for building and running the unit tests")
endif()

# install shared library
install(TARGETS ${LIBNAME}
  EXPORT QEverCloud-${QEVERCLOUD_QT_VERSION}LibraryDepends
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# install public headers
foreach(ITEM ${PUBLIC_HEADERS})
  install(FILES ${ITEM} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${QEVERCLOUD_QT_VERSION}qevercloud)
endforeach()

foreach(ITEM ${NON_GENERATED_HEADERS})
  install(FILES ${ITEM} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${QEVERCLOUD_QT_VERSION}qevercloud)
endforeach()

foreach(ITEM ${GENERATED_HEADERS})
  install(FILES ${ITEM} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${QEVERCLOUD_QT_VERSION}qevercloud/generated)
endforeach()

# install cmake module
if(BUILD_SHARED)
  install(EXPORT QEverCloud-${QEVERCLOUD_QT_VERSION}LibraryDepends DESTINATION ${INSTALL_CMAKE_DIR})
  install(FILES ${QEVERCLOUD_BINARY_DIR}/QEverCloud-${QEVERCLOUD_QT_VERSION}Config.cmake DESTINATION ${INSTALL_CMAKE_DIR})
  install(FILES ${QEVERCLOUD_BINARY_DIR}/QEverCloud-${QEVERCLOUD_QT_VERSION}ConfigVersion.cmake DESTINATION ${INSTALL_CMAKE_DIR})
endif()

=== QEverCloudGenerator/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(QEverCloudGenerator)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
include(QEverCloudSetupQt)
include(QEverCloudCompilerSettings)

add_subdirectory(lemon)
get_directory_property(lemon DIRECTORY lemon DEFINITION PROJECT_NAME)
get_directory_property(lempar DIRECTORY lemon DEFINITION lempar)

add_subdirectory(thrift_parser)
get_directory_property(thrift_parser DIRECTORY thrift_parser DEFINITION PROJECT_NAME)

add_subdirectory(generated)

=== QEverCloudGenerator/generated/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(generated)

file(GLOB thrift_files "${CMAKE_CURRENT_SOURCE_DIR}/../thrift/*.thrift")

set(GENERATED_FILENAMES
    types.h
    types_impl.h
    types.cpp
    services.h
    services.cpp
    EDAMErrorCode.h
    constants.h
    constants.cpp)

foreach(GENERATED_FILENAME ${GENERATED_FILENAMES})
    set(GENERATED_FILE "${CMAKE_CURRENT_BINARY_DIR}/${GENERATED_FILENAME}")

    add_custom_command(OUTPUT "${GENERATED_FILE}"
                       COMMAND ${CMAKE_COMMAND} -E echo "Generating file ${GENERATED_FILENAME}..."
                       COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/generated"
                       COMMAND ${thrift_parser} "${CMAKE_CURRENT_SOURCE_DIR}/../thrift/src/" "${CMAKE_CURRENT_BINARY_DIR}/generated/"
                       COMMAND ${CMAKE_COMMAND} -E echo "Ran thrift parser on thrift sources to generate ${GENERATED_FILE}" 
                       DEPENDS ${thrift_files})

                   add_custom_target(generate_${GENERATED_FILENAME} ALL DEPENDS "${GENERATED_FILE}")
endforeach()

=== QEverCloudGenerator/thrift_parser/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(thrift_parser)

set(HEADERS
    Generator.h
    Lexer.h
    Parser.h
    ParserHelper.h)

set(SOURCES
    Generator.cpp
    Lexer.cpp
    main.cpp
    Parser.cpp)

# Pre build step: copy thrift_lemon.y to build dir, execute lemon on it and remove the output file
add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/thrift_lemon.out"
                   COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/thrift_lemon.y" "${CMAKE_CURRENT_BINARY_DIR}"
                   COMMAND ${CMAKE_COMMAND} -E echo "thrift_lemon.y was copied to build dir"
                   COMMAND ${lemon} "${CMAKE_CURRENT_BINARY_DIR}/thrift_lemon.y"
                   COMMAND ${CMAKE_COMMAND} -E echo "lemon was executed on thrift_lemon.y"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/thrift_lemon.y")

add_custom_target(pre_build
                  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/thrift_lemon.out"
                  SOURCES thrift_lemon.y)

list(APPEND IDL_COMPILED_FILES "${CMAKE_CURRENT_BINARY_DIR}/thrift_lemon.h")
list(APPEND IDL_COMPILED_FILES "${CMAKE_CURRENT_BINARY_DIR}/thrift_lemon.cpp")

set_source_files_properties(${IDL_COMPILED_FILES}
                            PROPERTIES GENERATED TRUE)

add_executable(${PROJECT_NAME} ${HEADERS} ${SOURCES} ${IDL_COMPILED_FILES})
target_link_libraries(${PROJECT_NAME} ${QT_LIBRARIES})

add_dependencies(${PROJECT_NAME} pre_build)

=== debian/changelog ===
qevercloud (3.0.3+ds-6) unstable; urgency=high

  * Add texlive-plain-generic as build-dependency to solve
    FTBFS. (Closes: #955641)

 -- Boyuan Yang <byang@debian.org>  Sat, 11 Apr 2020 12:49:58 -0400

qevercloud (3.0.3+ds-5) unstable; urgency=high

  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.4.1.
    + Build-depends on qtbase5-dev:native. (Closes: #933208)
    + Update my maintainer email address.

 -- Boyuan Yang <byang@debian.org>  Tue, 05 Nov 2019 16:06:42 -0500

qevercloud (3.0.3+ds-4) unstable; urgency=medium

  * Expected to be the last release of qevercloud 3.x.
  * d/control: Bump Standards-Version to 4.1.4 (no changes needed).
  * d/control: Migrate to Salsa platform for Vcs fields.
  * d/rules: Apply "dh_missing --fail-missing".

 -- Boyuan Yang <073plan@gmail.com>  Sun, 06 May 2018 09:10:24 +0800

qevercloud (3.0.3+ds-3) unstable; urgency=medium

  * d/patches: refresh patch 0003 to fix FTBFS with gcc-7.
    (Closes: #871202)
  * d/control: bump Standards-Version to 4.0.1 (no changes needed)
  * d/control: remove Qt4-related package for upcoming Qt4 removal.
  * d/rules: review and remove Qt4 related instructions.

 -- Boyuan Yang <073plan@gmail.com>  Fri, 18 Aug 2017 10:11:01 +0800

qevercloud (3.0.3+ds-2) unstable; urgency=medium

  * d/control: update VCS links.
  * d/control: set Multi-Arch hints.
    - set qevercloud-doc as M-A: foreign.
    - set qt5qevercloud-dev as M-A: same.
    - set qt4qevercloud-dev as M-A: same.

 -- Boyuan Yang <073plan@gmail.com>  Sat, 14 Jan 2017 15:27:01 +0800

qevercloud (3.0.3+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #836857)

 -- Boyuan Yang <073plan@gmail.com>  Fri, 14 Oct 2016 11:01:28 +0800

=== debian/control ===
Source: qevercloud
Priority: optional
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake (>= 3.0.2),
 debhelper-compat (= 12),
 doxygen,
 ghostscript,
 lemon,
 libqt5webkit5-dev,
 qtbase5-dev:native,
 qttools5-dev (>= 5.2.1),
 qttools5-dev-tools (>= 5.2.1),
 texlive-binaries,
 texlive-plain-generic,
 texlive-font-utils,
 texlive-fonts-recommended,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/d1vanov/QEverCloud
Vcs-Git: https://salsa.debian.org/debian/qevercloud.git
Vcs-Browser: https://salsa.debian.org/debian/qevercloud

Package: libqt5qevercloud3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Unofficial Evernote Cloud API library for Qt5
 QEverCloud presents a rather complete Evernote SDK for Qt.
 Nearly all the functionality described on the Evernote site
 is implemented and ready to use.
 .
 This library works with Qt5.

Package: qevercloud-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: QEverCloud library documentation
 QEverCloud presents a rather complete Evernote SDK for Qt.
 Nearly all the functionality described on the Evernote site
 is implemented and ready to use.
 .
 This package provides the documentation for the library.

Package: qt5qevercloud-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libqt5qevercloud3 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 qevercloud-doc,
Description: Development files for libqt5qevercloud
 QEverCloud presents a rather complete Evernote SDK for Qt.
 Nearly all the functionality described on the Evernote site
 is implemented and ready to use.
 .
 This package provides development files for libqt5qevercloud.

=== debian/watch ===
version=4
opts="dversionmangle=s/(\+\d*)?\+ds\d*$//,pgpmode=none,repack,compression=xz,repacksuffix=+ds," https://github.com/d1vanov/QEverCloud/tags /.*/.*/.*/v?(.+)\.tar\.gz debian uupdate
